<?php

namespace STM\Match\Lineup;

use STM\Match\Match;
use STM\StmFactory;

/**
 * Test class for Lineups.
 * Generated by PHPUnit on 2012-07-11 at 12:51:54.
 * @group match_lineup
 */
class LineupsTest extends \PHPUnit_Framework_TestCase {

    /** @var Match */
    private $match;
    /** @var Lineups */
    private $lineups;

    protected function setUp() {
        $this->match = StmFactory::find()->Match->findById (5);
        if ($this->match) {
            $this->lineups = new Lineups($this->match);
        }
    }

    public function testGet_lineup() {
        if ($this->match) {
            parent::assertTrue(is_array($this->lineups->getLineupHome()));
            parent::assertTrue(is_array($this->lineups->getLineupAway()));
            foreach ($this->lineups->getLineupHome() as $player) {
                $this->assert_player_from_lineup($player);
            }
            foreach ($this->lineups->getLineupAway() as $player) {
                $this->assert_player_from_lineup($player);
            }
        }
    }

    /** @param MatchPlayer $player */
    private function assert_player_from_lineup($player) {
        parent::assertInstanceOf('\STM\Match\Lineup\MatchPlayer', $player);
        // test getPlayer
        $player_from_lineup = $this->lineups->getPlayer($player->getIdTeamPlayer());
        parent::assertInstanceOf('\STM\Match\Lineup\MatchPlayer', $player_from_lineup);
        parent::assertEquals($player->getIdMatchPlayer(), $player_from_lineup->getIdMatchPlayer());
        // test getSubstitutionPlayer
        $substitution_player = $this->lineups->getSubstitutionPlayer($player->getIdSubstitutionPlayer());
        if ($player->getIdSubstitutionPlayer()) {
            parent::assertInstanceOf('\STM\Match\Lineup\MatchPlayer', $substitution_player);
            parent::assertEquals($player->getIdSubstitutionPlayer(), $substitution_player->getIdMatchPlayer());
        } else {
            parent::assertFalse($substitution_player);
        }
    }

}

?>